﻿using System;
using System.Web.UI;

namespace Mazin.SPGoogleMapPart
{
    public partial class MapEditorPartUserControl : UserControl
    {
        public double CentreLatitude
        {
            get { return Double.Parse(centreLatitude.Text); }
            set { centreLatitude.Text = value.ToString(); }
        }

        public double CentreLongitude
        {
            get { return Double.Parse(centreLongitude.Text); }
            set { centreLongitude.Text = value.ToString(); }
        }

        public int MapHeight
        {
            get { return Int32.Parse(mapHeight.Text); }
            set { mapHeight.Text = value.ToString(); }
        }

        public string MapType
        {
            get { return mapType.SelectedValue; }
            set { mapType.SelectedValue = value; }
        }

        public int MapWidth
        {
            get { return Int32.Parse(mapWidth.Text); }
            set { mapWidth.Text = value.ToString(); }
        }

        public int ZoomLevel
        {
            get { return Int32.Parse(zoom.SelectedValue); }
            set { zoom.SelectedValue = value.ToString(); }
        }

        public string AddressColumn
        {
            get { return addressColumnName.Text; }
            set { addressColumnName.Text = value; }
        }

        public string LongitudeColumn
        {
            get { return lngColumnName.Text; }
            set { lngColumnName.Text = value; }
        }

        public string LatitudeColumn
        {
            get { return latColumnName.Text; }
            set { latColumnName.Text = value; }
        }

        public string DescriptionColumn
        {
            get { return descrColumName.Text; }
            set { descrColumName.Text = value; }
        }

        public string TitleColumn
        {
            get { return titleColumnName.Text; }
            set { titleColumnName.Text = value; }
        }

        public string ListUrl
        {
            get { return listUrl.Text; }
            set { listUrl.Text = value; }
        }

        public string WebUrl
        {
            get { return webUrl.Text; }
            set { webUrl.Text = value; }
        }

        public string ListQuery
        {
            get { return camlQuery.Text; }
            set { camlQuery.Text = value; }
        }

        public string ListItemIdParamName
        {
            get { return urlIdParamName.Text; }
            set { urlIdParamName.Text = value; }
        }

        public int DataMode
        {
            get { return Int32.Parse(dataMode.SelectedValue); }
            set { dataMode.SelectedValue = value.ToString(); }
        }

        protected void Page_Load(object sender, EventArgs e)
        {
        }

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
            Page.ClientScript.RegisterStartupScript(GetType(), "setupScript",
                                                    String.Format(
                                                        "<script type=\"text/javascript\">DataModeChanged(document.getElementById('{0}'));</script>",
                                                        dataMode.ClientID));
        }
    }
}