﻿using System.ComponentModel;
using System.Web.UI.WebControls.WebParts;

namespace Mazin.SPGoogleMapPart
{
    [ToolboxItem(false)]
    public class MapEditorPart : EditorPart
    {
        // Visual Studio might automatically update this path when you change the Visual Web Part project item.
        private const string _ascxPath = @"~/_CONTROLTEMPLATES/SPGoogleMapPart/MapEditorPartUserControl.ascx";
        private MapEditorPartUserControl _control;

        protected override void CreateChildControls()
        {
            _control = (MapEditorPartUserControl) Page.LoadControl(_ascxPath);
            Controls.Add(_control);
        }

        public override bool ApplyChanges()
        {
            bool retVal = true;
            //from editorpart tu webpart properties
            VisualWebPart webpart = (VisualWebPart) WebPartToEdit;
            webpart.ZoomLevel = _control.ZoomLevel;
            webpart.MapWidth = _control.MapWidth;
            webpart.MapHeight = _control.MapHeight;
            webpart.WebUrl = _control.WebUrl;
            webpart.TitleColumn = _control.TitleColumn;
            webpart.MapType = _control.MapType;
            webpart.LongitudeColumn = _control.LongitudeColumn;
            webpart.LatitudeColumn = _control.LatitudeColumn;
            webpart.ListUrl = _control.ListUrl;
            webpart.ListQuery = _control.ListQuery;
            webpart.ListItemIdParamName = _control.ListItemIdParamName;
            webpart.CentreLongitude = _control.CentreLongitude;
            webpart.CentreLatitude = _control.CentreLatitude;
            webpart.AddressColumn = _control.AddressColumn;
            webpart.DescriptionColumn = _control.DescriptionColumn;
            webpart.DataMode = _control.DataMode;
            return retVal;
        }

        public override void SyncChanges()
        {
            //from webpart to editpart
            VisualWebPart webpart = (VisualWebPart) WebPartToEdit;
            EnsureChildControls();
            _control.ZoomLevel = webpart.ZoomLevel;
            _control.MapWidth = webpart.MapWidth;
            _control.MapHeight = webpart.MapHeight;
            _control.WebUrl = webpart.WebUrl;
            _control.TitleColumn = webpart.TitleColumn;
            _control.MapType = webpart.MapType;
            _control.LongitudeColumn = webpart.LongitudeColumn;
            _control.LatitudeColumn = webpart.LatitudeColumn;
            _control.ListUrl = webpart.ListUrl;
            _control.ListQuery = webpart.ListQuery;
            _control.ListItemIdParamName = webpart.ListItemIdParamName;
            _control.CentreLongitude = webpart.CentreLongitude;
            _control.CentreLatitude = webpart.CentreLatitude;
            _control.AddressColumn = webpart.AddressColumn;
            _control.DescriptionColumn = webpart.DescriptionColumn;
            _control.DataMode = webpart.DataMode;
        }
    }
}