﻿using System;
using System.Globalization;
using System.Text;
using System.Web.UI;

namespace Mazin.SPGoogleMapPart
{
    public partial class VisualWebPartUserControl : UserControl
    {
        public double CentreLatitude = 49.846175;
        public double CentreLongitude = 18.429136;
        public int MapHeight = 300;
        public string MapType = "HYBRID";
        public int MapWidth = 400;
        internal Marker[] Markers;
        public int Zoom = 0x13;

        protected override void OnPreRender(EventArgs e)
        {
            base.OnPreRender(e);
            GenerateMarkersScript();
        }

        private void GenerateMarkersScript()
        {
            if (Markers == null || Markers.Length == 0) return;

            StringBuilder itemsSetupScript = new StringBuilder("<script type=\"text/javascript\">");
            for (int i = 0; i < Markers.Length; i++)
            {
                Marker marker = Markers[i];
                itemsSetupScript.AppendFormat(
                    "var mr{4} = new google.maps.Marker({{position: new google.maps.LatLng({2}, {3}),map: map,title: '{0}'}});google.maps.event.addListener(mr{4}, 'click', function () {{var iw = new google.maps.InfoWindow({{content: '{1}'}});iw.open(map, mr{4});}});",
                    marker.Title.Replace('\n', ' '),
                    marker.Description == null ? "" : marker.Description.Replace('\n', ' ').Replace('\r', ' '),
                    marker.Latitude.ToString(CultureInfo.InvariantCulture),
                    marker.Longitude.ToString(CultureInfo.InvariantCulture), i);
            }
            itemsSetupScript.Append("</script>");
            Page.ClientScript.RegisterStartupScript(GetType(), "itemsSetupScript", itemsSetupScript.ToString());
        }
    }
}